Redmine - Feature #33071

Prevent accidental deletion of contents with sudo mode
2020-03-01 10:16 - Go MAEDA

Status: Reopened Start date:

Priority: Normal Due date:

Assignee: Go MAEDA % Done: 0%
Category: ul Estimated time: 0.00 hour
Target version: Candidate for next major release

Resolution: Fixed

Description

The attached patch adds protection against deletion of contents such as issues, wiki pages, and attachments by expanding
operations covered by sudo mode that has been added in Redmine 3.1 (#19851).

Users sometimes mistakenly delete contents like issues. | think it is because deleting contents is so easy if they have appropriate
permissions.

I think such accidents can be reduced with sudo mode. If sudo mode guards deletion of contents as well by requiring re-entering a
password, users can have an opportunity to reconsider the operation.

Step 1: the user see "Are you sure?" dialog after clicking "Delete" button. Not a few users press OK without thinking.

Are you sure you want to delete the selected issue(s)?
Step 2: if sudo mode is enabled in configuration.yml and the attached patch is applied, Redmine requires user to re-enter
their password before performing deletion. The user may notice that they are doing a daingerous operation.
Related issues:
Related to Redmine - Feature #2893: Add a view to confirm issue deletion Reopened 2009-03-04
Related to Redmine - Feature #34417: Require explicit confirmation when delet... Closed
https://www.redmine.org/issues/19851

Associated revisions

Revision 19569 - 2020-03-10 04:26 - Go MAEDA

Require sudo mode for actions to delete contents (#33071).

Patch by Go MAEDA.

Revision 19579 - 2020-03-14 04:49 - Go MAEDA
Reverts r19569 (#33071).

404 error after deleting an attachment.

History

#1 - 2020-03-05 04:54 - Go MAEDA

- Related to Feature #2893: Add a view to confirm issue deletion added

#2 - 2020-03-07 08:12 - Go MAEDA
- File 0001-Require-sudo-mode-for-actions-to-delete-contents.patch added

- Target version set to Candidate for next major release

Added tests to the patch.

#3 - 2020-03-08 00:24 - Go MAEDA

- Target version changed from Candidate for next major release to 4.2.0

Setting the target version to 4.2.0.

#4 - 2020-03-08 10:48 - Marius BALTEANU

The instances without sudo mode enabled won't be able to use this feature, right?
#5 - 2020-03-08 12:14 - Go MAEDA
Marius BALTEANU wrote:

The instances without sudo mode enabled won't be able to use this feature, right?

Yes, that is right. The patch extends sudo mode, so there is no change in behavior on Redmine instances without sudo mode enabled.

#6 - 2020-03-10 04:27 - Go MAEDA
- Status changed from New to Closed
- Assignee set to Go MAEDA

- Resolution set to Fixed
Committed the patch.
#7 - 2020-03-10 08:53 - Marius BALTEANU
Go MAEDA wrote:
Committed the patch.
Even if the patch is already committed, | think it's too much to require the password for delete actions and to have this feature only for the instances
with sudo mode enabled. | think making the delete action harder, it's good idea. What | saw in the last period in many web applications (starting from
cloud platforms to Github, Gitlab) it's a custom confirmation modal that requires a manual input like "yes" from the user in order to continue the action.

Also, in some cases like issue page, the delete button it's easily mismatch with the delete button from comment and what we can do there is to hide
the button under actions dropdown.

I'm reopening this to take more feedback from the users, | don't think that such a change should go so quickly in the next release.

#8 - 2020-03-10 08:54 - Marius BALTEANU

- Status changed from Closed to Reopened
#9 - 2020-03-10 13:23 - Go MAEDA

It will be nice if an alternative implementation is introduced before the release of 4.2.0.

But | believe that a mechanism to guard contents against such accidents is indispensable and the sudo mode works well until another mechanism is
implemented. | will happily replace this if another patch is suggested.

Before that, | think the sudo mode is a good workaround. Probably not many instances enable sudo mode, the instances influenced by this extended
sudo mode are limited. So, most users Redmine can delete contents as usual even after their instance is upgraded.

#10 - 2020-07-11 23:09 - Miodrag Milic
| support Go Maeda in this.

This happens so frequently (even to those like me that use Redmine daily for decade, due to that funky journal delete button being on wrong place)
that its better to have current implementation then wait for something else. Is it really important what | type ? yes or password ?

This should eventually support bulk operation (not sure if it does now). It is very important for spammy plugins like service desks.

#11 - 2020-12-09 08:14 - Marius BALTEANU

- Related to Feature #34417: Require explicit confirmation when deleting a user or a project added

#12 - 2020-12-09 08:16 - Marius BALTEANU

- Target version changed from 4.2.0 to Candidate for next major release
We can use the implementation proposed in #33071 to have this ticket done.
#13 - 2020-12-10 04:55 - Go MAEDA

Marius BALTEANU wrote:

We can use the implementation proposed in #33071 to have this ticket done.

Indeed. It is a nicer solution.

#14 - 2021-01-06 04:39 - Jens Kramer

We had actually thought about doing something like this for issue deletion as well, but found it a bit too intrusive in the end.
Few things | just thought about:

- we could use an overlay for the confirmation dialog instead of leading to another page. This would simply replace the 'Are you sure' alert that exists
in many cases with something more meaningful, without distracting too much.

- for issues or other 'less important' entities, give the user an option to turn off the confirmation requirement until the end of the day. This would relieve
people doing 'cleanup' style tasks from having to confirm each and every action.

- entering 'yes' (in case of bulk delete) or the issue id should be sufficient (I would not want to use the password for this kind of confirmation).

Files

0001-Require-sudo-mode-for-deleting-contents.patch 6.61 KB 2020-03-01 Go MAEDA

deletion-step-1@2x.png 78.5 KB 2020-03-01 Go MAEDA

deletion-step-2@2x.png 28.4 KB 2020-03-01 Go MAEDA

0001-Require-sudo-mode-for-actions-to-delete-contents.patch 8.08 KB 2020-03-07 Go MAEDA
